// --------------------------------------------------------------------------------------------------------------------
// <copyright file="BaseField.cs" company="">
//   
// </copyright>
// <summary>
//   The base field.
// </summary>
// --------------------------------------------------------------------------------------------------------------------

namespace entity.MetaEditor2
{
    using System;
    using System.Windows.Forms;

    using HaloMap.Map;

    /// <summary>
    /// The base field.
    /// </summary>
    /// <remarks></remarks>
    partial class BaseField : UserControl
    {
        #region Constants and Fields

        /// <summary>
        /// The ent name.
        /// </summary>
        public string EntName = "Error in getting plugin element name";

        /// <summary>
        /// The line number.
        /// </summary>
        public int LineNumber;

        /// <summary>
        /// The chunk offset.
        /// </summary>
        public int chunkOffset;

        /// <summary>
        /// The map index.
        /// </summary>
        public Map mapIndex;

        /// <summary>
        /// The offset in map.
        /// </summary>
        public int offsetInMap;

        #endregion

        #region Constructors and Destructors

        /// <summary>
        /// Initializes a new instance of the <see cref="BaseField"/> class.
        /// </summary>
        /// <remarks></remarks>
        public BaseField()
        {
            this.Leave += BaseField_Leave;
        }

        #endregion

        #region Public Methods

        /// <summary>
        /// The base field_ leave.
        /// </summary>
        /// <param name="sender">The sender.</param>
        /// <param name="e">The e.</param>
        /// <remarks></remarks>
        public virtual void BaseField_Leave(object sender, EventArgs e)
        {
        }

        /// <summary>
        /// The save.
        /// </summary>
        /// <exception cref="NotImplementedException">
        ///   </exception>
        /// <remarks></remarks>
        public virtual void Save()
        {
            throw new NotImplementedException("Error Saving " + this.GetType());
        }

        #endregion
    }
}