﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Xml;

namespace Globals
{
    /// <summary>
    /// 
    /// </summary>
    /// <remarks></remarks>
    public static class Prefs
    {
        /// <summary>
        /// Gets the file path.
        /// </summary>
        /// <remarks></remarks>
        public static string FilePath { get; private set; }

        /// <summary>
        /// The check update.
        /// </summary>
        public static updateFrequency checkUpdate = updateFrequency.Daily;

        /// <summary>
        /// The last check.
        /// </summary>
        public static DateTime lastCheck = DateTime.MinValue;

        /// <summary>
        /// The path bitmaps.
        /// </summary>
        public static string pathBitmaps = "bitmap.map";

        /// <summary>
        /// The path clean maps.
        /// </summary>
        public static string pathCleanMaps = Global.StartupPath + "\\Orig";

        /// <summary>
        /// The path extract folder.
        /// </summary>
        public static string pathExtractFolder = Global.StartupPath;

        /// <summary>
        /// The path last file.
        /// </summary>
        public static List<RecentFile> RecentOpenedMaps = new List<RecentFile>();

        /// <summary>
        /// 
        /// </summary>
        /// <remarks></remarks>
        public class RecentFile
        {
            /// <summary>
            /// 
            /// </summary>
            public string Path;

            /// <summary>
            /// 
            /// </summary>
            public MenuItem MenuItem;
        }

        /// <summary>
        /// 
        /// </summary>
        public const int MaxRecentFiles = 4;

        /// <summary>
        /// The path mainmenu.
        /// </summary>
        public static string pathMainmenu = "mainmenu.map";

        /// <summary>
        /// The path map folder.
        /// </summary>
        public static string pathMapFolder = Global.StartupPath;

        /// <summary>
        /// The path patch folder.
        /// </summary>
        public static string pathPatchFolder = Global.StartupPath;

        /// <summary>
        /// The path plugins folder.
        /// </summary>
        public static string pathPluginsFolder = Global.StartupPath + @"\Plugins\Halo 2\ent\";

        /// <summary>
        /// The path sp shared.
        /// </summary>
        public static string pathSPShared = "single_player_shared.map";

        /// <summary>
        /// The path shared.
        /// </summary>
        public static string pathShared = "shared.map";

        /// <summary>
        /// The use default maps.
        /// </summary>
        public static bool useDefaultMaps = true;

        #region Enums

        /// <summary>
        /// The update frequency.
        /// </summary>
        /// <remarks></remarks>
        public enum updateFrequency
        {
            /// <summary>
            /// The always.
            /// </summary>
            Always,

            /// <summary>
            /// The daily.
            /// </summary>
            Daily,

            /// <summary>
            /// The weekly.
            /// </summary>
            Weekly,

            /// <summary>
            /// The monthly.
            /// </summary>
            Monthly,

            /// <summary>
            /// The never.
            /// </summary>
            Never
        }

        #endregion

        /// <summary>
        /// 
        /// </summary>
        /// <remarks></remarks>
        public class CustomPluginMask
        {
            /// <summary>
            /// Gets or sets the name.
            /// </summary>
            /// <value>The name.</value>
            /// <remarks></remarks>
            public string Name { get; set; }

            /// <summary>
            /// Gets the visible tag types.
            /// </summary>
            /// <remarks></remarks>
            public List<string> VisibleTagTypes { get; private set; }

            /// <summary>
            /// Initializes a new instance of the <see cref="T:System.Object"/> class.
            /// </summary>
            /// <remarks></remarks>
            public CustomPluginMask ()
            {
                VisibleTagTypes = new List<string>();
            }
        }

        /// <summary>
        /// Gets the custom plugin masks.
        /// </summary>
        /// <remarks></remarks>
        public static List<CustomPluginMask> CustomPluginMasks { get; private set; }

        /// <summary>
        /// Gets the quick access tag types.
        /// </summary>
        /// <remarks></remarks>
        public static List<QuickAccessTagType> QuickAccessTagTypes { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        /// <remarks></remarks>
        public class QuickAccessTagType
        {
            /// <summary>
            /// 
            /// </summary>
            public string TagType;

            /// <summary>
            /// 
            /// </summary>
            public List<string> TagPaths;

            /// <summary>
            /// Initializes a new instance of the <see cref="T:System.Object"/> class.
            /// </summary>
            /// <remarks></remarks>
            public QuickAccessTagType()
            {
                TagPaths = new List<string>();
            }
        }

        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_MAINMENUPATH = "mainmenu";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_MPSHAREDATH = "mpshared";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_SPSHAREDPATH = "spshared";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_BITMAPSPATH = "bitmaps";

        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_MAPSDIR = "mapsDir";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_CLEANMAPSDIR = "cleanmapsDir";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_PLUGINSDIR = "pluginsDir";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_PATCHDIR = "patchDir";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_EXTRACTS = "extractsDir";

        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_USEDEFMAPS = "useDefaultMaps";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_CHECKUPDATE = "checkUpdate";

        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_RECENTMAPSLIST = "recentMapsList";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_RECENTMAP = "recentMap";

        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_QUICKACCESSTAGSLIST = "quickAccessTagList";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_QUICKACCESSTAG = "quickAccessTag";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_QUICKACCESSTAGPATH = "tagPath";

        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_USERPLUGINMASKS = "userPluginMasks";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_PLUGINMASK = "pluginMask";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_ATTR_PLUGINMASKNAME = "name";
        /// <summary>
        /// 
        /// </summary>
        private const string XML_NODE_PLUGINMASK_VISIBLETAGTYPE = "visibleTagType";

        /// <summary>
        /// 
        /// </summary>
        private const string XML_ATTR_TAGTYPENAME = "name";

        /// <summary>
        /// Initializes a new instance of the <see cref="T:System.Object"/> class.
        /// </summary>
        /// <remarks></remarks>
        static Prefs()
        {
            FilePath = Global.StartupPath + "\\User Settings.xml";
            CustomPluginMasks = new List<CustomPluginMask>();
            QuickAccessTagTypes = new List<QuickAccessTagType>();
        }

        /// <summary>
        /// Gets the type of the quick access tag.
        /// </summary>
        /// <param name="tagType">Type of the tag.</param>
        /// <returns></returns>
        /// <remarks></remarks>
        public static QuickAccessTagType GetQuickAccessTagType(string tagType)
        {
            for (int i = 0 ; i<QuickAccessTagTypes.Count;i++)
            {
                if (QuickAccessTagTypes[i].TagType == tagType) return QuickAccessTagTypes[i];
            }
            return null;
        }

        /// <summary>
        /// Returns true if file was loaded
        /// </summary>
        /// <returns></returns>
        /// <remarks></remarks>
        public static bool Load()
        {
            // check for file
            if (!File.Exists(FilePath)) return false;

            XmlDocument doc = new XmlDocument();

            //try
            //{
                // load settings into document
            doc.Load(FilePath);

                // loop rootnode's nodes, and depending on what node we find
                // do a different action.
                foreach (XmlNode node in doc.DocumentElement.ChildNodes)
                {
                    switch (node.Name)
                    {
                        case XML_NODE_MAINMENUPATH:
                            {
                                pathMainmenu = node.InnerText;
                                break;
                            }
                        case XML_NODE_MPSHAREDATH:
                            {
                                pathShared = node.InnerText;
                                break;
                            }
                        case XML_NODE_SPSHAREDPATH:
                            {
                                pathSPShared = node.InnerText;
                                break;
                            }
                        case XML_NODE_BITMAPSPATH:
                            {
                                pathBitmaps = node.InnerText;
                                break;
                            }

                        case XML_NODE_MAPSDIR:
                            {
                                pathMapFolder = node.InnerText;
                                break;
                            }
                        case XML_NODE_CLEANMAPSDIR:
                            {
                                pathCleanMaps = node.InnerText;
                                break;
                            }
                        case XML_NODE_PLUGINSDIR:
                            {
                                pathPluginsFolder = node.InnerText;
                                break;
                            }
                        case XML_NODE_PATCHDIR:
                            {
                                pathPatchFolder = node.InnerText;
                                break;
                            }
                        case XML_NODE_EXTRACTS:
                            {
                                pathExtractFolder = node.InnerText;
                                break;
                            }

                        case XML_NODE_USEDEFMAPS:
                            {
                                useDefaultMaps = bool.Parse(node.InnerText);
                                break;
                            }
                        case XML_NODE_CHECKUPDATE:
                            {
                                checkUpdate = (updateFrequency)Enum.Parse(typeof(updateFrequency), node.InnerText);
                                break;
                            }

                        case XML_NODE_RECENTMAPSLIST:
                            {
                                foreach (XmlNode recentMapNode in node)
                                {
                                    RecentFile rf = new RecentFile();
                                    rf.Path = recentMapNode.InnerText;
                                    RecentOpenedMaps.Add(rf);
                                }
                                break;
                            }
                        case XML_NODE_QUICKACCESSTAGSLIST:
                            {
                                foreach (XmlNode quickAccessNode in node)
                                {
                                    QuickAccessTagType quickAcess = new QuickAccessTagType();
                                    quickAcess.TagType = quickAccessNode.Attributes[XML_ATTR_TAGTYPENAME].InnerText;
                                    foreach (XmlNode tagPathNode in quickAccessNode)
                                    {
                                        //switch (tagPathNode.Name)
                                        //{
                                        //    case XML_NODE_QUICKACCESSTAGPATH:
                                        //        {
                                                    quickAcess.TagPaths.Add(tagPathNode.InnerText);
                                        //            break;
                                        //        }

                                        //}
                                    }
                                    QuickAccessTagTypes.Add(quickAcess);
                                }
                                break;
                            }
                        case XML_NODE_USERPLUGINMASKS:
                            {
                                foreach (XmlNode pluginMaskNode in node)
                                {
                                    CustomPluginMask mask = new CustomPluginMask();
                                    mask.Name = pluginMaskNode.Attributes[XML_ATTR_PLUGINMASKNAME].InnerText;

                                    foreach (XmlNode maskNode in pluginMaskNode)
                                    {
                                        //switch (maskNode.Name)
                                        //{
                                        //    case XML_NODE_PLUGINMASK_VISIBLETAGTYPE:
                                        //        {
                                                    mask.VisibleTagTypes.Add(
                                                        maskNode.Attributes[XML_ATTR_TAGTYPENAME].InnerText);
                                        //            break;
                                        //        }

                                        //}
                                    }

                                    CustomPluginMasks.Add(mask);
                                }
                                break;
                            }
                    }
                }
            //}
            //catch (Exception e)
            //{
            //    Global.ShowErrorMsg("User settings read fail.", e);
            //    return false;
            //}

            return true;
        }

        /// <summary>
        /// Saves this instance.
        /// </summary>
        /// <remarks></remarks>
        public static void Save()
        {
            XmlTextWriter writer = new XmlTextWriter(FilePath, Encoding.ASCII);
            writer.Formatting = Formatting.Indented;
            writer .WriteStartDocument();

            writer.WriteStartElement("entityUserSettings");
            writer.WriteElementString(XML_NODE_MAINMENUPATH, pathMainmenu);
            writer.WriteElementString(XML_NODE_MPSHAREDATH, pathShared);
            writer.WriteElementString(XML_NODE_SPSHAREDPATH, pathSPShared);
            writer.WriteElementString(XML_NODE_BITMAPSPATH, pathBitmaps);

            writer.WriteElementString(XML_NODE_MAPSDIR, pathMapFolder);
            writer.WriteElementString(XML_NODE_CLEANMAPSDIR, pathCleanMaps);
            writer.WriteElementString(XML_NODE_PLUGINSDIR, pathPluginsFolder);
            writer.WriteElementString(XML_NODE_PATCHDIR, pathPatchFolder);
            writer.WriteElementString(XML_NODE_EXTRACTS, pathExtractFolder);

            writer.WriteElementString(XML_NODE_USEDEFMAPS, useDefaultMaps.ToString());
            writer.WriteElementString(XML_NODE_CHECKUPDATE, checkUpdate.ToString());

            writer.WriteStartElement(XML_NODE_RECENTMAPSLIST);
            for (int i = 0; i < RecentOpenedMaps.Count; i++)
            {
                writer.WriteElementString(XML_NODE_RECENTMAP, RecentOpenedMaps[i].Path);
            }
            writer.WriteEndElement();

            writer.WriteStartElement(XML_NODE_QUICKACCESSTAGSLIST);
            for (int i = 0; i < QuickAccessTagTypes.Count; i++)
            {
                writer.WriteStartElement(XML_NODE_QUICKACCESSTAG);
                writer.WriteAttributeString(XML_ATTR_TAGTYPENAME, QuickAccessTagTypes[i].TagType);
                foreach (string tagPath in QuickAccessTagTypes[i].TagPaths)
                {
                    writer.WriteElementString(XML_NODE_QUICKACCESSTAGPATH, tagPath);
                }
                writer.WriteEndElement();
            }
            writer.WriteEndElement();

            writer.WriteStartElement(XML_NODE_USERPLUGINMASKS);
            foreach (CustomPluginMask mask in CustomPluginMasks)
            {
                writer.WriteStartElement(XML_NODE_PLUGINMASK);
                writer.WriteAttributeString(XML_ATTR_PLUGINMASKNAME, mask.Name);
                foreach (string tagType in mask.VisibleTagTypes)
                {
                    writer.WriteStartElement(XML_NODE_PLUGINMASK_VISIBLETAGTYPE);
                    writer.WriteAttributeString(XML_ATTR_TAGTYPENAME, tagType);
                    writer.WriteEndElement();
                }
                writer.WriteEndElement();
            }
            writer.WriteEndElement();

            writer.WriteEndElement();
            writer.Close();
        }
    }
}
