// --------------------------------------------------------------------------------------------------------------------
// <copyright file="RTH.cs" company="">
//   
// </copyright>
// <summary>
//   The rth data.
// </summary>
// --------------------------------------------------------------------------------------------------------------------

namespace HaloMap.RealTimeHalo
{
    using System.Runtime.InteropServices;

    /// <summary>
    /// The rth data.
    /// </summary>
    /// <remarks></remarks>
    public class RTHData
    {
        #region Constants and Fields

        /// <summary>
        /// The connected.
        /// </summary>
        public bool Connected;

        /// <summary>
        /// The x box ip addy.
        /// </summary>
        public string XBoxIPAddy = "0.0.0.0";

        #endregion
    }

    /// <summary>
    /// The rt h_ imports.
    /// </summary>
    /// <remarks></remarks>
    public class RTH_Imports
    {
        #region Public Methods

        /// <summary>
        /// The convert float.
        /// </summary>
        /// <param name="f">The f.</param>
        /// <returns>The convert float.</returns>
        /// <remarks></remarks>
        [DllImport("RthDLL.dll", CharSet = CharSet.Ansi)]
        public static extern uint ConvertFloat(float f);

        /// <summary>
        /// The de init rth.
        /// </summary>
        /// <remarks></remarks>
        [DllImport("RthDLL.dll", CharSet = CharSet.Ansi)]
        public static extern void DeInitRTH();

        /// <summary>
        /// The get uint.
        /// </summary>
        /// <param name="Addr">The addr.</param>
        /// <returns>The get uint.</returns>
        /// <remarks></remarks>
        [DllImport("RthDLL.dll", CharSet = CharSet.Ansi)]
        public static extern uint GetUint(uint Addr);

        /// <summary>
        /// The go.
        /// </summary>
        /// <remarks></remarks>
        [DllImport("RthDLL.dll", CharSet = CharSet.Ansi)]
        public static extern void Go();

        /// <summary>
        /// The init rth.
        /// </summary>
        /// <param name="IP">The ip.</param>
        /// <returns>The init rth.</returns>
        /// <remarks></remarks>
        [DllImport("RthDLL.dll", CharSet = CharSet.Ansi)]
        public static extern int InitRTH(string IP);

        /// <summary>
        /// The poke.
        /// </summary>
        /// <param name="Addr">The addr.</param>
        /// <param name="Data">The data.</param>
        /// <param name="size">The size.</param>
        /// <remarks></remarks>
        [DllImport("RthDLL.dll", CharSet = CharSet.Ansi)]
        public static extern void Poke(uint Addr, uint Data, int size);

        /// <summary>
        /// The stop.
        /// </summary>
        /// <remarks></remarks>
        [DllImport("RthDLL.dll", CharSet = CharSet.Ansi)]
        public static extern void Stop();

        #endregion
    }
}